#pragma once
#include "arc_interface.h"

class CArchiverAISH:public CArchiverDLL{
protected:
	bool HasFiles(LPCTSTR);
public:
	CArchiverAISH();
	virtual ~CArchiverAISH();
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR,LPCTSTR,LPCTSTR,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false){return false;}
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool bSkipDir,bool &,bool &,CString&,CString &strErr);
	virtual bool InspectArchiveNext(){return false;}
	virtual bool QueryInspectSupported()const{return false;}
	virtual bool QueryExtractSpecifiedOnlySupported()const{return false;}
	virtual BOOL CheckArchive(LPCTSTR);
	virtual bool IsWeakCheckArchive()const{return true;}	//CheckArchive̋@\n(UNBEL/AISĤ悤)ǂ
	virtual bool IsWeakErrorCheck()const{return true;}	//%Prefix%()̃G[`FbNÂ(XacRett̂悤)Ȃtrue
};


enum ISH_ENCODE_TYPE{
	ISH_SHIFT_JIS,
	ISH_JIS7,
	ISH_JIS8,
	ISH_NON_KANA_SHIFT_JIS,

	ENUM_COUNT_AND_LASTITEM(ISH_ENCODE_TYPE),
};
