#include "stdafx.h"
#include "../ArchiverCode/ArchiverJACK.h"
#include "ConfigManager.h"
#include "ConfigJACK.h"

void CConfigJACK::load(CONFIG_SECTION &Config)
{
	// JACKkݒ
	SpecifyVolumeSizeAtCompress=Config.Data[_T("SpecifyAtCompress")].GetNParam(TRUE);
	VolumeSize=Config.Data[_T("VolumeSize")].GetNParam(1423);
	if(VolumeSize<=0){
		VolumeSize=1423;
	}
}

void CConfigJACK::store(CONFIG_SECTION &Config)const
{
	// JACKkݒ
	Config.Data[_T("SpecifyAtCompress")]=SpecifyVolumeSizeAtCompress;
	Config.Data[_T("VolumeSize")]=VolumeSize;
}

void CConfigJACK::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("JACK")));
}

void CConfigJACK::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("JACK")));
}
