#pragma once
#include "../Utilities/Utility.h"
#include "../FileListWindow/MenuCommand.h"
#include "../Utilities/ConfigFile.h"

//----------
// ݒǗ
//----------
//INIt@C
const LPCTSTR INI_FILE_NAME=_T("LhaForge.ini");
const LPCTSTR CALDIX_INI_FILE_NAME=_T("LFCaldix.ini");
const LPCTSTR PROGRAMDIR_NAME=_T("LhaForge");	//ApplicationDataɓƂɕKvȃfBNg


enum PARAMETER_TYPE;

class CConfigManager;
struct IConfigConverter{
protected:
	virtual void load(CONFIG_SECTION&)=0;	//ݒCONFIG_SECTIONǂݍ
	virtual void store(CONFIG_SECTION&)const=0;	//ݒCONFIG_SECTIONɏ
public:
	virtual ~IConfigConverter(){}
	virtual void load(CConfigManager&)=0;
	virtual void store(CConfigManager&)const=0;
};

//====================================
// ݒǗNX
//====================================

class CConfigManager
{
protected:
	CString m_strIniPath;
	CString m_strCaldixIniPath;
	bool m_bUserCommon;	//[U[Ԃŋʂ̐ݒgꍇtrue;\Ŏg߂ɗp
	typedef std::map<stdString,CONFIG_SECTION,less_ignorecase> CONFIG_DICT;
	CONFIG_DICT m_Config;
	CONFIG_DICT m_CaldixConfig;
public:
	CConfigManager();
	virtual ~CConfigManager();
	void SetConfigFile(LPCTSTR);	//ݒt@Cw
	bool LoadConfig(CString &strErr);
	bool SaveConfig(CString &strErr);
	CONFIG_SECTION &GetSection(LPCTSTR lpszSection);
	CONFIG_SECTION &GetCaldixSection(LPCTSTR lpszSection);
	void DeleteSection(LPCTSTR lpszSection);
	bool HasSection(LPCTSTR lpszSection)const;
	void WriteUpdateTime(time_t=time(NULL));
	bool IsUserCommon(){return m_bUserCommon;}	//[U[ԋʐݒH
};

