#include "stdafx.h"
#include "../ArchiverCode/ArchiverUNHKI.h"
#include "ConfigManager.h"
#include "ConfigUNHKI.h"

// HKIkݒ
void CConfigHKI::load(CONFIG_SECTION &Config)
{
	//kx
	CompressLevel=(HKI_COMPRESS_LEVEL)Config.Data[_T("CompressLevel")].GetNParam(0,HKI_COMPRESS_LEVEL_LAST_ITEM,0);
	//ÍASY
	EncryptAlgorithm=(HKI_ENCRYPT_ALGORITHM)Config.Data[_T("EncryptAlgorithm")].GetNParam(0,HKI_ENCRYPT_ALGORITHM_LAST_ITEM,0);
}

void CConfigHKI::store(CONFIG_SECTION &Config)const
{
	//kx
	Config.Data[_T("CompressLevel")]=CompressLevel;
	//ÍASY
	Config.Data[_T("EncryptAlgorithm")]=EncryptAlgorithm;
}

void CConfigHKI::load(CConfigManager &ConfMan)
{
	load(ConfMan.GetSection(_T("HKI")));
}

void CConfigHKI::store(CConfigManager &ConfMan)const
{
	store(ConfMan.GetSection(_T("HKI")));
}
