#include "stdafx.h"
#include "Dlg_compress_general.h"
#include "../../ArchiverCode/arc_interface.h"
#include "../../Dialogs/selectdlg.h"
#include "../../Dialogs/LFFolderDialog.h"
#include "../../compress.h"

//==================
// kʐݒ
//==================
LRESULT CConfigDlgCompressGeneral::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//------------------
	// ko͐^Cv
	//------------------
	Radio_CompressTo[OUTPUT_TO_DESKTOP]=GetDlgItem(IDC_RADIO_COMPRESS_TO_DESKTOP);
	Radio_CompressTo[OUTPUT_TO_SAME_DIR]=GetDlgItem(IDC_RADIO_COMPRESS_TO_SAME_DIR);
	Radio_CompressTo[OUTPUT_TO_SPECIFIC_DIR]=GetDlgItem(IDC_RADIO_COMPRESS_TO_SPECIFIC_DIR);
	Radio_CompressTo[OUTPUT_TO_ALWAYS_ASK_WHERE]=GetDlgItem(IDC_RADIO_COMPRESS_TO_ALWAYS_ASK_WHERE);

	Radio_CompressTo[m_Config.OutputDirType].SetCheck(1);

	//----------------------------------------------------
	// o͐tH_̃pXGfBbgRg[ɐݒ
	//----------------------------------------------------
	Edit_CompressOutputDirPath=GetDlgItem(IDC_EDIT_COMPRESS_TO_SPECIFIC_DIR);
	Edit_CompressOutputDirPath.SetLimitText(_MAX_PATH);
	Edit_CompressOutputDirPath.SetWindowText(m_Config.OutputDir);

	Button_CompressToFolder=GetDlgItem(IDC_BUTTON_COMPRESS_BROWSE_FOLDER);

	//o͐w肷邽߂̃{^ƃGfBbgRg[̗L؂ւ
	bool bActive=(OUTPUT_TO_SPECIFIC_DIR==m_Config.OutputDirType);
	Edit_CompressOutputDirPath.EnableWindow(bActive);
	Button_CompressToFolder.EnableWindow(bActive);

	//--------------------------------
	// Ɉkt@C̏
	//--------------------------------
	UpDown_MaxCompressFileCount=GetDlgItem(IDC_SPIN_MAX_COMPRESS_FILECOUNT);

	UpDown_MaxCompressFileCount.SetPos(m_Config.MaxCompressFileCount);
	UpDown_MaxCompressFileCount.SetRange(1,32767);

	UpDown_MaxCompressFileCount.EnableWindow(m_Config.LimitCompressFileCount);
	::EnableWindow(GetDlgItem(IDC_EDIT_MAX_COMPRESS_FILECOUNT),m_Config.LimitCompressFileCount);

	//uɈkt@C𐧌v`FbN{bNX
	Check_LimitCompressFileCount=GetDlgItem(IDC_CHECK_LIMIT_COMPRESS_FILECOUNT);

	//--------------------------
	// ftHgkp[^
	//--------------------------
	Check_UseDefaultParameter=GetDlgItem(IDC_CHECK_USE_DEFAULTPARAMETER);
	Edit_DefaultParameterInfo=GetDlgItem(IDC_EDIT_DEFAULTPARAMETER);

	::EnableWindow(GetDlgItem(IDC_BUTTON_SELECT_DEFAULTPARAMETER),m_Config.UseDefaultParameter);

	SetParameterInfo();

	//DDXݒ
	DoDataExchange(FALSE);

	return TRUE;
}

LRESULT CConfigDlgCompressGeneral::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//------------------
	// ko͐^Cv
	//------------------
	for(int Type=0;Type<COUNTOF(Radio_CompressTo);Type++){
		if(Radio_CompressTo[Type].GetCheck()){
			m_Config.OutputDirType=(OUTPUT_TO)Type;
			break;
		}
	}
	//----------------------
	// o͐tH_̃pX
	//----------------------
	Edit_CompressOutputDirPath.GetWindowText(m_Config.OutputDir);

	//--------------------------------
	// Ɉkt@C̏
	//--------------------------------
	m_Config.MaxCompressFileCount=UpDown_MaxCompressFileCount.GetPos();

	//---------------
	// DDXf[^擾
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}

	//------------------------------------------------
	// t@Ci[ĂtH_Jǂ
	//-------------------------------------------------
//	m_Config.Compress.OpenDir=Check_OpenDirAfterCompress.GetCheck();
	return TRUE;
}

LRESULT CConfigDlgCompressGeneral::OnRadioCompressTo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		bool bActive=(0!=Radio_CompressTo[OUTPUT_TO_SPECIFIC_DIR].GetCheck());
		Edit_CompressOutputDirPath.EnableWindow(bActive);
		Button_CompressToFolder.EnableWindow(bActive);
	}
	return 0;
}

LRESULT CConfigDlgCompressGeneral::OnBrowseFolder(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		TCHAR FolderPath[_MAX_PATH+1];
		FILL_ZERO(FolderPath);

		Edit_CompressOutputDirPath.GetWindowText(FolderPath,_MAX_PATH);

		CString title(MAKEINTRESOURCE(IDS_INPUT_TARGET_FOLDER));
		CLFFolderDialog dlg(m_hWnd,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
		dlg.SetInitialFolder(FolderPath);
		if(IDOK==dlg.DoModal()){
			_tcsncpy_s(FolderPath,dlg.GetFolderPath(),_MAX_PATH);
			Edit_CompressOutputDirPath.SetWindowText(FolderPath);
		}
	}
	return 0;
}

LRESULT CConfigDlgCompressGeneral::OnCheckLimitCompressFileCount(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		BOOL State=Check_LimitCompressFileCount.GetCheck();
		UpDown_MaxCompressFileCount.EnableWindow(State);
		::EnableWindow(GetDlgItem(IDC_EDIT_MAX_COMPRESS_FILECOUNT),State);
	}
	return 0;
}

//ftHgkp[^̗L
LRESULT CConfigDlgCompressGeneral::OnCheckUseDefaultParameter(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		BOOL State=Check_UseDefaultParameter.GetCheck();
		::EnableWindow(GetDlgItem(IDC_BUTTON_SELECT_DEFAULTPARAMETER),State);
	}
	return 0;
}

//ftHgkp[^̑I
LRESULT CConfigDlgCompressGeneral::OnSelectDefaultParameter(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		int Options=-1;
		bool bSingleCompression=false;	//
		bool bB2ESFX=false;
		CString strB2EFormat,strB2EMethod;

		//`I_CAO
		PARAMETER_TYPE CompressType=SelectCompressType(Options,bSingleCompression,strB2EFormat,strB2EMethod,bB2ESFX);
		if(CompressType==PARAMETER_UNDEFINED)return 1;	//LZ

		if(CompressType!=PARAMETER_B2E){	//ʏDLLgp
			//I_CAȌɈvp[^
			int Index=0;
			for(;Index<COMPRESS_PARAM_COUNT;Index++){
				if(CompressType==CompressParameterArray[Index].Type){
					if(Options==CompressParameterArray[Index].Options){
						break;
					}
				}
			}
			if(Index>=COMPRESS_PARAM_COUNT){
				//ꗗɎw肳ꂽkȂ
				//܂AT|[gĂȂkƂ
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_ILLEGAL_FORMAT_TYPE)));
				return 1;
			}else{
				//ݒۑ
				m_Config.DefaultType=CompressType;
				m_Config.DefaultOptions=Options;

				SetParameterInfo();//EditɌ݂̃p[^̏\
				return 0;
			}
		}else{	//B2E32.dllgp
			//p[^
			if(bB2ESFX){
				m_Config.DefaultOptions=TRUE;
			}else{
				m_Config.DefaultOptions=0;
			}
			m_Config.DefaultType=CompressType;
			m_Config.DefaultB2EFormat=strB2EFormat;
			m_Config.DefaultB2EMethod=strB2EMethod;
			SetParameterInfo();//EditɌ݂̃p[^̏\
			return 0;
		}
	}
	return 0;
}


void CConfigDlgCompressGeneral::SetParameterInfo()//EditɌ݂̃p[^̏\
{
	if(m_Config.DefaultType==PARAMETER_UNDEFINED){
		//`
		Edit_DefaultParameterInfo.SetWindowText(_T(""));
	}else if(m_Config.DefaultType!=PARAMETER_B2E){	//ʏDLLgp
		//I_CAȌɈvp[^
		int Index=0;
		for(;Index<COMPRESS_PARAM_COUNT;Index++){
			if(m_Config.DefaultType==CompressParameterArray[Index].Type){
				if(m_Config.DefaultOptions==CompressParameterArray[Index].Options){
					break;
				}
			}
		}
		if(Index>=COMPRESS_PARAM_COUNT){
			//ꗗɎw肳ꂽkȂ
			//܂AT|[gĂȂkƂ
			Edit_DefaultParameterInfo.SetWindowText(CString(MAKEINTRESOURCE(IDS_ERROR_ILLEGAL_FORMAT_TYPE)));
		}
		else{
			//Ȑݒ
			Edit_DefaultParameterInfo.SetWindowText(CString(MAKEINTRESOURCE(CompressParameterArray[Index].FormatName)));
		}
	}else{	//B2E32.dllgp
		CString strInfo;
		BOOL bB2ESFX=m_Config.DefaultOptions;
		if(bB2ESFX){
			//ȉ
			strInfo.Format(IDS_FORMAT_NAME_B2E_SFX,m_Config.DefaultB2EFormat,m_Config.DefaultB2EMethod);
		}else{
			strInfo.Format(IDS_FORMAT_NAME_B2E,m_Config.DefaultB2EFormat,m_Config.DefaultB2EMethod);
		}
		Edit_DefaultParameterInfo.SetWindowText(strInfo);
	}
}
