#pragma once

#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../ArchiverCode/ArchiverXACRETT.h"
#include "../ConfigXACRETT.h"
#include "../../resource.h"

//====================================
// XACRETT̐ݒ荀
//====================================
class CConfigDlgXACRETT : public CDialogImpl<CConfigDlgXACRETT>,public CWinDataExchange<CConfigDlgXACRETT>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigXACRETT	m_Config;

	CButton Check_EnableXacrett;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_XACRETT };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigDlgXACRETT)
		DDX_TEXT(IDC_EDIT_XACRETT_PRIORITY_EXTENSION, m_Config.Extensions)
		DDX_CHECK(IDC_CHECK_ENABLE_XACRETT_MENU, m_Config.EnableShellMenu)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgXACRETT)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_ENABLE_XACRETT,OnCheckEnableXacrett)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnCheckEnableXacrett(WORD,WORD,HWND,BOOL&);

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

