#pragma once

//Original code from http://hp.vector.co.jp/authors/VA016117/
//Modified by Claybird http://claybird.sakura.ne.jp/

class IDropCommunicator{	//CDropTargetƃhbv󂯓EBhEʐM邽߂ɎgC^[tFCX;hbOƏʂȂ߂̂悤ȍ\ɂȂĂ
public:
	virtual ~IDropCommunicator(){}
	virtual HRESULT DragEnter(IDataObject*,POINTL&,DWORD&)=0;
	virtual HRESULT DragLeave()=0;
	virtual HRESULT DragOver(IDataObject*,POINTL&,DWORD&)=0;
	virtual HRESULT Drop(IDataObject*,POINTL&,DWORD&)=0;
};

class CDropTarget : public IDropTarget
{
protected:
	LONG _RefCount;
	IDropCommunicator *m_lpCommunicator;
	IDataObject *m_lpDataObject;
public:
	CDropTarget(IDropCommunicator *lpComm):_RefCount(1),m_lpCommunicator(lpComm),m_lpDataObject(NULL){}
	virtual ~CDropTarget(){};

	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef(void);
	virtual ULONG __stdcall Release(void);

	virtual HRESULT __stdcall DragEnter(IDataObject* pDataObject, DWORD grfKeyState, POINTL ptl, DWORD* pdwEffect);
	virtual HRESULT __stdcall DragOver(DWORD grfKeyState, POINTL ptl, DWORD* pdwEffect);
	virtual HRESULT __stdcall DragLeave();
	virtual HRESULT __stdcall Drop(IDataObject* pDataObject, DWORD grfKeyState, POINTL ptl, DWORD* pdwEffect);

	//---
	bool QueryFormat(CLIPFORMAT cfFormat);
	HRESULT GetDroppedFiles(IDataObject *lpDataObject,std::list<CString>&);
};

