#include "stdafx.h"
#include "ShellDataManager.h"
#include "../ArchiverCode/ArcEntryInfo.h"

int CShellDataManager::GetIconIndex(LPCTSTR Ext)
{
	std::hash_map<StlString,SHELLDATA>::iterator ite=ShellDataMap.find(Ext);
	if(ite!=ShellDataMap.end()){
		//ɓo^Ă
		return (*ite).second.IconIndex;
	}
	//}bvɖo^o^

	ite=RegisterData(Ext);
	return (*ite).second.IconIndex;
}

LPCTSTR CShellDataManager::GetTypeName(LPCTSTR Ext)
{
	std::hash_map<StlString,SHELLDATA>::iterator ite=ShellDataMap.find(Ext);
	if(ite!=ShellDataMap.end()){
		//ɓo^Ă
		return (*ite).second.TypeName;
	}
	//}bvɖo^o^

	ite=RegisterData(Ext);
	return (*ite).second.TypeName;
}

std::hash_map<StlString,SHELLDATA>::iterator CShellDataManager::RegisterData(LPCTSTR Ext,DWORD Attribute)
{
	SHELLDATA ShellData;
	//t@C ACR CfbNX擾
	SHFILEINFO shfi;
	SHGetFileInfo(Ext,Attribute,&shfi,sizeof(shfi),SHGFI_USEFILEATTRIBUTES|SHGFI_ICON|SHGFI_LARGEICON|SHGFI_SYSICONINDEX);
	ShellData.IconIndex=shfi.iIcon;

	//t@C`擾
	SHGetFileInfo(Ext,Attribute,&shfi,sizeof(shfi),SHGFI_USEFILEATTRIBUTES|SHGFI_TYPENAME);
	ShellData.TypeName=shfi.szTypeName;

	std::pair<std::hash_map<StlString,SHELLDATA>::iterator,bool> Result;

	Result=ShellDataMap.insert(std::pair<StlString,SHELLDATA>(Ext,ShellData));
	return Result.first;
}


void CShellDataManager::Init()
{
//	ImageListLarge.Create(::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CXICON), ILC_COLORDDB | ILC_MASK, 8, 1);
//	ImageListSmall.Create(::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CXSMICON), ILC_COLORDDB | ILC_MASK, 8, 1);
	SHFILEINFO shfi;
	ImageListLarge=(HIMAGELIST)SHGetFileInfo(_T(""),0,&shfi,sizeof(shfi),SHGFI_SYSICONINDEX | SHGFI_ICON | SHGFI_LARGEICON);
	ImageListSmall=(HIMAGELIST)SHGetFileInfo(_T(""),0,&shfi,sizeof(shfi),SHGFI_SYSICONINDEX | SHGFI_ICON | SHGFI_SMALLICON);
	//ACR(tH_p)𒊏o
	RegisterData(FOLDER_EXTENSION_STRING,FILE_ATTRIBUTE_DIRECTORY);
}

HIMAGELIST CShellDataManager::GetImageList(bool bLarge)
{
	if(bLarge){
		return ImageListLarge;
	}
	else{
		return ImageListSmall;
	}
}

