#pragma once
#include "arc_interface.h"

class CArchiverBGA:public CArchiverDLL{
public:
	CArchiverBGA();
	virtual ~CArchiverBGA();
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR,LPCTSTR,LPCTSTR,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false);
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool,bool&,bool&,CString&,CString &strErr);

	//A[JCut@C폜
	virtual bool DeleteItemFromArchive(LPCTSTR ArcFileName,CConfigManager&,const std::list<CString>&,CString &);
	virtual bool QueryDeleteItemFromArchiveSupported()const{return true;}		//DeleteFileT|[gĂ邩ǂ

	//A[JCuɎw肵t@Cǉ
	virtual bool AddItemToArchive(LPCTSTR ArcFileName,const std::list<CString>&,CConfigManager&,LPCTSTR lpDestDir,CString&);
	virtual bool QueryAddItemToArchiveSupported()const{return true;}

};


enum{
	GZA_COMPRESS_LEVEL_LOWEST=1,
	GZA_COMPRESS_LEVEL_HIGHEST=9,
	BZA_COMPRESS_LEVEL_LOWEST=1,
	BZA_COMPRESS_LEVEL_HIGHEST=9
};
