#pragma once
#include "arc_interface.h"

class CArchiverCAB:public CArchiverDLL{
protected:
	void EnumAndWriteSubDir(HANDLE,LPCTSTR);
	bool ExtractAlternative(LPCTSTR,CConfigManager&,const CConfigExtract&,LPCTSTR,CString &strLog);
public:
	CArchiverCAB();
	virtual ~CArchiverCAB();
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR,LPCTSTR,LPCTSTR,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false);
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool,bool&,bool&,CString&,CString &strErr);
	virtual ARCRESULT TestArchive(LPCTSTR,CString &);	//A[JCuǂ`FbN
};

enum CAB_COMPRESS_TYPE{
	CAB_COMPRESS_MSZIP,
	CAB_COMPRESS_LZX,
	CAB_COMPRESS_PLAIN,
//	CAB_COMPRESS_QUANTUM,

	ENUM_COUNT_AND_LASTITEM(CAB_COMPRESS_TYPE)
};

#define CAB_LZX_LOWEST	15
#define CAB_LZX_HIGHEST	21

