#pragma once
#include "arc_interface.h"
#include "../resource.h"

class CArchiverTAR:public CArchiverDLL{
protected:
	COMMON_ARCHIVER_OPENARCHIVE2 ArchiverOpenArchive2;
public:
	CArchiverTAR();
	virtual ~CArchiverTAR();
	virtual LOAD_RESULT LoadDLL(CConfigManager&,CString &strErr);
	virtual void FreeDLL();
	virtual bool InspectArchiveBegin(LPCTSTR,CConfigManager&);				//ɓJn

	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR,LPCTSTR,LPCTSTR,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false);
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool,bool&,bool&,CString&,CString &strErr);
};

enum{
	GZIP_COMPRESS_LEVEL_LOWEST=1,
	GZIP_COMPRESS_LEVEL_HIGHEST=9,
	BZIP2_COMPRESS_LEVEL_LOWEST=1,
	BZIP2_COMPRESS_LEVEL_HIGHEST=9
};
