#pragma once
#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/arc_interface.h"
#include "../ConfigGeneral.h"

//====================================
// ʐݒ荀
//====================================
class CConfigDlgGeneral : public CDialogImpl<CConfigDlgGeneral>,public CMessageFilter,public CWinDataExchange<CConfigDlgGeneral>,public IConfigDlgBase
{
protected:
	CConfigGeneral	m_Config;
	CButton Radio_LostDir[LOSTDIR_ITEM_COUNT];
	CButton Radio_LogView[LOGVIEW_ITEM_COUNT];

	CButton Check_UseFiler;
	CEdit Edit_FilerPath;
	CEdit Edit_FilerParam;
	CButton Button_BrowseFiler;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnCheckFiler(WORD,WORD,HWND,BOOL&);
	LRESULT OnBrowseFiler(WORD,WORD,HWND,BOOL&);
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_GENERAL };
	// DDX}bv
	BEGIN_DDX_MAP(CConfigDlgGeneral)
		DDX_CHECK(IDC_CHECK_WARN_NETWORK,m_Config.WarnNetwork)
		DDX_CHECK(IDC_CHECK_WARN_REMOVABLE,m_Config.WarnRemovable)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgGeneral)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_USE_FILER,OnCheckFiler)
		COMMAND_ID_HANDLER(IDC_BUTTON_BROWSE_FILER,OnBrowseFiler)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnApply();

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}


	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

