#pragma once
#include "../resource.h"
#include "../TestArchive.h"

class CLogListDialog:public CDialogImpl<CLogListDialog>,public CDialogResize<CLogListDialog>, public CCustomDraw<CLogListDialog>
{
protected:
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);

	//CSplitterWindow	m_SplitterWindow;	// Xvb^EBhE
	CListViewCtrl	m_ItemListView;		// t@Cꗗ
	CEdit			m_MsgEdit;			// ʂ̃bZ[W\p
	CEdit			m_PathEdit;			// ʂ̃t@C\p

	std::vector<ARCLOG>	m_LogArray;		//ʂ̔z
	bool				m_bAllOK;		//ׂĂOKȂtrue
	CString				m_strCaption;	//_CAÕLvV

	//--------------
	// Xgr[
	//--------------
	LRESULT OnGetDispInfo(LPNMHDR pnmh);	//zXgr[̃f[^擾
	LRESULT OnItemChanged(LPNMHDR pnmh);	//I̕ύX
	LRESULT OnSortItem(LPNMHDR pnmh);		//\[g
	int m_nSortColumn;						//\[gɎg
	bool m_bSortDescending;					//\[gȂfalse


	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CLogListDialog)
		NOTIFY_CODE_HANDLER_EX(LVN_GETDISPINFO, OnGetDispInfo)
		MSG_WM_INITDIALOG(OnInitDialog)
//		COMMAND_ID_HANDLER_EX(IDOK, OnEnd)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnEnd)
		NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnItemChanged)
		MSG_WM_CTLCOLORSTATIC(OnCtrlColorEdit)
		NOTIFY_CODE_HANDLER_EX(LVN_COLUMNCLICK, OnSortItem)
		CHAIN_MSG_MAP(CCustomDraw<CLogListDialog>)    // CCustomDrawNXփ`F[
		CHAIN_MSG_MAP(CDialogResize<CLogListDialog>)    // CDialogResizeNXւ̃`F[
//		REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

	void OnEnd(UINT uNotifyCode, int nID, HWND hWndCtl){
		EndDialog(nID);
	}

	// _CAOTCY}bv
	BEGIN_DLGRESIZE_MAP(CLogListDialog)
		DLGRESIZE_CONTROL(IDC_LIST_LOGINFO_ITEMS,DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDC_STATIC_MOVABLE1,DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_STATIC_MOVABLE2,DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_EDIT_LOGINFO_FILE,DLSZ_SIZE_X|DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_STATIC_LOGINFO,DLSZ_SIZE_X|DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_EDIT_LOGINFO_MSG,DLSZ_MOVE_X|DLSZ_SIZE_X|DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	//JX^h[
	DWORD OnPrePaint(int nID, LPNMCUSTOMDRAW);
	DWORD OnItemPrePaint(int nID, LPNMCUSTOMDRAW);

	//Rg[̐F:ǂݎpGfBbg
	HBRUSH OnCtrlColorEdit(HDC,HWND);
public:
	CLogListDialog(LPCTSTR lpszCaption):m_strCaption(lpszCaption),m_nSortColumn(-1),m_bSortDescending(false){}
	enum {IDD = IDD_DIALOG_LOGLIST};

	//OZbg
	void SetLogArray(const std::vector<ARCLOG>&);
};
