#include "stdafx.h"
#include "TestArchive.h"
#include "ArchiverManager.h"
#include "ConfigCode/ConfigManager.h"
#include "Dialogs/LogListDialog.h"
#include "Dialogs/ProgressDlg.h"
#include "Utilities/StringUtil.h"

bool TestArchive(const std::list<CString> &rArcList)
{
	CArchiverDLLManager &ArchiverManager=CArchiverDLLManager::GetInstance();

	//XacRett̓`FbNÂߎgȂ

	//vOXo[
	CProgressDialog dlg;
	int nFiles=rArcList.size();
	dlg.Create(NULL);
	dlg.SetTotalFileCount(nFiles);
	dlg.ShowWindow(SW_SHOW);


	std::list<CString>::const_iterator ite=rArcList.begin();
	const std::list<CString>::const_iterator end=rArcList.end();

	//eXgʂi[
	std::vector<ARCLOG> LogArray;
	for(;ite!=end;++ite){
		//vOXo[i߂
		if(dlg.IsWindow())dlg.SetNextState(*ite);

		//A[JConh擾
		//NOTE:DenyExtɂΏۍi荞݂͊ɍsĂ̂2͍sȂ
		CArchiverDLL *Archiver=ArchiverManager.GetArchiver(*ite,NULL);

		ARCLOG ArcLog;
		ArcLog.strFile=*ite;
		if(!Archiver){
			//---ΉnhȂ:𒲍
			//ʏ̃G[
			ArcLog.strMsg.Format(IDS_ERROR_ILLEGAL_HANDLER,*ite);
			ArcLog.Result=TEST_NOTARCHIVE;

			//UNICODE֌W̃`FbN
			if(!UtilCheckT2A(*ite)){
				//UNICODEɑΉĂȂ̂UNICODEt@C̃t@CƂ
				ArcLog.strMsg+=_T("\r\n\r\n");
				ArcLog.strMsg.AppendFormat(IDS_ERROR_UNICODEPATH);
			}
		}else{
			CString strTemp;
			ArcLog.Result=Archiver->TestArchive(*ite,strTemp);
			ArcLog.strMsg=Archiver->GetName();
			ArcLog.strMsg+=_T("\r\n\r\n");
			ArcLog.strMsg+=strTemp;
		}
		LogArray.push_back(ArcLog);
	}
	//vOXo[
	if(dlg.IsWindow())dlg.DestroyWindow();

	//Oɕ\
	CLogListDialog LogDlg(CString(MAKEINTRESOURCE(IDS_LOGINFO_OPERATION_TESTARCHIVE)));
	LogDlg.SetLogArray(LogArray);
	LogDlg.DoModal();

	return true;
}


